import * as wasm from './magnetic_pendulum_bg.wasm';

const lTextDecoder = typeof TextDecoder === 'undefined' ? (0, module.require)('util').TextDecoder : TextDecoder;

let cachedTextDecoder = new lTextDecoder('utf-8', { ignoreBOM: true, fatal: true });

cachedTextDecoder.decode();

let cachedUint8Memory0 = new Uint8Array();

function getUint8Memory0() {
    if (cachedUint8Memory0.byteLength === 0) {
        cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8Memory0;
}

function getStringFromWasm0(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}
/**
*/
export function greet() {
    wasm.greet();
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
    return instance.ptr;
}
/**
*/
export class Magnet {

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_magnet_free(ptr);
    }
}
/**
*/
export class Pendulum {

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_pendulum_free(ptr);
    }
}
/**
*/
export class Universe {

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_universe_free(ptr);
    }
    /**
    * @param {Magnet} magnet
    */
    add_magnet(magnet) {
        _assertClass(magnet, Magnet);
        var ptr0 = magnet.ptr;
        magnet.ptr = 0;
        wasm.universe_add_magnet(this.ptr, ptr0);
    }
    /**
    */
    clear_magnets() {
        wasm.universe_clear_magnets(this.ptr);
    }
    /**
    * @param {Pendulum} pendulum
    */
    add_pendulum(pendulum) {
        _assertClass(pendulum, Pendulum);
        var ptr0 = pendulum.ptr;
        pendulum.ptr = 0;
        wasm.universe_add_pendulum(this.ptr, ptr0);
    }
    /**
    */
    clear_pendulums() {
        wasm.universe_clear_pendulums(this.ptr);
    }
}

export function __wbg_alert_99721415dbbf9ca4(arg0, arg1) {
    alert(getStringFromWasm0(arg0, arg1));
};

export function __wbindgen_throw(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
};

